BEGIN { 
	fontname = "FontName";
	in_bitmap = 0; 
	isbold=0;
	isitalic=0;
	width = 0;
	maxwidth = 0;
	maxheight= 0;
	maxunder = 0;
	for (i=0; i<512; i++) { widths[i] = 0; heights[i] = 0; }
	for (i=0; i<512; i++) { indices[i] = 0; }
	for (i=0; i<512; i++) { x_offset[i] = 0; }
	for (i=0; i<512; i++) { y_offset[i] = 0; }
	for (i=0; i<256; i++) { negative_charno_names[i] = ""; }
	ix = 0;
	negative_charno_counter = 256;
	printf ("\n/* Font file created by bdf2c.awk by Zach Smith */\n\n");
	printf ("#include <stdio.h>\n");
	printf ("#include \"font.h\"\n");
	printf ("static unsigned char bytes[]={\n");
}

# /FACE_NAME/ { printf ("static char* facename = %s\n", $2); }
/^SLANT/ { 
	slant=substr ($2, 2, length($2)-2); 
	if (slant=="O") { isitalic=1; }
	else if (slant=="I") { isitalic=1; }
	if (weight=="Medium") { weight="M"; }
	else if (weight=="Bold") { weight="B"; }
	fontname = sprintf ("%s%s%s%d", family_compact,slant,weight,size); 
}
/^FONTBOUNDINGBOX/ { 
	maxwidth = (0 + $2);
	maxheight= (0 + $3);
	maxunder = (0 + $5);
}
/^COMMENT / { str=substr($0,9); printf ("/* %s */\n", str); }
/^FONT / { longname=substr($0, 6); }
/^FACE_NAME/ { 
	facename=substr($0,11); 
	facename=substr(facename,2,length(facename)-2);
}
/^FAMILY_NAME/ { 
	family = substr ($0, 1 + index ($0, "\""));
	family = substr (family, 1, -1 + index (family, "\""));
	family_compact = family
	gsub (/ /, "", family_compact);
}
/^WEIGHT_NAME/ { 
	weight=substr ($2, 2, length($2)-2); 
	if (weight=="Bold") isbold=1;
}
/^SIZE/ { size=0 + $2; }
/^FONT_ASCENT/ { ascent=0 + $2; }
/^FONT_DESCENT/ { descent=0 + $2; }
/^ENDCHAR/ { in_bitmap = 0; ix = nextix; }
/^[0123456789ABCDEF]/ { 
	if (in_bitmap) {
		if (width > 32) {
			printf (" *&*&*&* FONT IS TOO WIDE *&*&*&\n");
		} else
		if (width > 24 && width <= 32) {
			printf ("0x%s,0x%s,0x%s,0x%s,\n", 
				substr($1,1,2), 
				substr($1,3,2),
				substr($1,5,2),
				substr($1,7,2)) ; 
		} else
		if (width > 16 && width <= 24) {
			printf ("0x%s,0x%s,0x%s,\n", 
				substr($1,1,2), 
				substr($1,3,2),
				substr($1,5,2)) ; 
		} else
		if (width > 8 && width <= 16) {
			printf ("0x%s,0x%s,\n", substr($1,1,2), substr($1,3,2)) ; 
		} else {
			printf ("0x%s,\n", $1) ; 
		}
	}
}
/^STARTCHAR/ { name = $2; }
/^COPYRIGHT/ { printf ("/* %s */\n", $0); }
/^ENCODING/ { 
	charno = 0 + $2 ; 
	if (charno < 0) charno = negative_charno_counter++;
	negative_charno_names[charno] = name;
	printf ("/* char %s */\n", $2) ; 
}
/^BBX/ { 
	widths[charno] = 0 + $2; 
	heights[charno] = 0 + $3; 
	indices[charno] = ix;
	x_offset[charno] = 0 + $4; 
	y_offset[charno] = 0 + $5; 
	
	width= 0 + $2; 
	printf ("/* width = %d */\n",width); 
	printf ("/* height = %s */\n", $3); 
	nextix = ix + 0 + $3;
	if (width > 8) 
		nextix = nextix + 0 + $3;
	if (width > 16)
		nextix = nextix + 0 + $3;
	if (width > 24)
		nextix = nextix + 0 + $3;
}
/^BITMAP/ { in_bitmap = 1; }

END {
	lim = negative_charno_counter;

	printf ("};\n\n");
	printf ("\n/* WIDTHS: */\nstatic unsigned char widths[] = {\n");
	for (i=0; i<lim; i++) { 
		printf ("/* %03d */ %d,\n", i, widths[i]);
	}
	printf ("};\n");

	printf ("\n/* INDICES : */\nstatic unsigned short indices[] = {\n");
	for (i=0; i<=lim; i++) { 
		printf ("/* %03d */ %d,\n", i, indices[i]);
	}
	printf ("/* end index */ %u,", nextix);
	printf ("};\n");

	printf ("\n/* x offsets */\n");
	printf ("static char x_offsets[] = {\n");
	for (i=0; i<lim; i++) {
		printf (" %d,\n", x_offset[i]);
	}
	printf ("};\n");

	printf ("\n/* y offsets */\n");
	printf ("static char y_offsets[] = {\n");
	for (i=0; i<lim; i++) {
		printf (" %d,\n", y_offset[i]);
	}
	printf ("};\n");

	if (lim>=256) {
		printf ("\n/* Names of non-numbered characters in BDF file */\n");
		printf ("static char *names [] = {\n");
		if (lim==256) {
			printf (" \"\"\n", negative_charno_names[i]);
		} else {
			for (i=256; i<lim; i++) {
				printf (" \"%s\",\n", negative_charno_names[i]);
			}
		}
		printf ("};\n");
	}

	printf ("\n\n");

	printf ("void\ngetbdf_%s (Font *f)\n{\n",fontname);
	if (substr(longname,1,1)=="\"") {
		longname = substr(longname,2,length(longname)-2);
	}
	if (substr(facename,1,1)=="\"") {
		facename = substr(facename,2,length(facename)-2);
	}

	printf ("\tf->family = \"%s\";\n", family);
	printf ("\tf->is_bold = %d;\n", isbold);
	printf ("\tf->is_slanted = %d;\n", isitalic);
	printf ("\tf->facename = \"%s\";\n", facename);
	printf ("\tf->longname = \"%s\";\n", longname);
	printf ("\tf->bytes = bytes;\n");
	printf ("\tf->widths = widths;\n");
	printf ("\tf->indices = indices;\n");
	printf ("\tf->x_offsets = x_offsets;\n");
	printf ("\tf->y_offsets = y_offsets;\n");
	printf ("\tf->total_chars = %d;\n", negative_charno_counter);

	if (lim>=256) {
		printf ("\tf->non_ansi_names = names;\n");
	} else {
		printf ("\tf->non_ansi_names = NULL;\n");
	}

	printf ("\tf->max_width = %u;\n", maxwidth);
	printf ("\tf->max_height = %u;\n", maxheight);
	printf ("\tf->ascent = %u;\n",ascent);
	printf ("\tf->descent = %u;\n",descent);
	printf ("\tf->size = %u;\n",size);
	printf ("}\n\n");
}


