
/*=============================================================================
   beest, an HTML viewer.
   Copyright (C) 2000 Zachary Thayer Smith

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   The author is reachable by electronic mail at zeyr@excite.com.
=============================================================================*/

/*----------------------------------------------------------------------
 * Module name:    color.h
 * Author name:    Zach Smith
 * Create date:    29 Nov 2000
 * Last change:    29 Nov 2000
 * Purpose:        Color type;
 *                 prototypes related to color translation.
 *----------------------------------------------------------------------
 * Changes:
 *--------------------------------------------------------------------*/

#ifndef _COLOR
#define _COLOR

#ifndef _STRING
#include "string.h"
#endif


/* A Color consists of 4 bytes:
 * byte 3: transparency (not used)
 * byte 2: red
 * byte 1: green
 * byte 0: blue
 */
typedef unsigned long Color;


#define INVALID_COLOR (0x1000000)


extern Color color_lookup (String);


#endif


