
/*=============================================================================
   beest, an HTML viewer.
   Copyright (C) 2000 Zachary Thayer Smith

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   The author is reachable by electronic mail at zeyr@excite.com.
=============================================================================*/

/*----------------------------------------------------------------------
 * Module name:    display.c
 * Author name:    Zach Smith
 * Create date:    1 Oct 2000
 * Last change:    26 Nov 2000
 * Purpose:        Display class
 *----------------------------------------------------------------------
 * Changes:
 *--------------------------------------------------------------------*/


#include <stdio.h>
#include <string.h>

#include "defs.h"
#include "malloc.h"
#include "main.h"
#include "error.h"
#include "display.h"


DisplayDevice*
display_new ()
{
	DisplayDevice* dpy;

	dpy = (DisplayDevice*) my_malloc (sizeof(DisplayDevice));
	if (!dpy)
		error_handler ("unable to allocate DisplayDevice object");

	/* Set it up without size or methods or callbacks.
	 * All these are defined in the device init function.
	 */
	memset ((void*)dpy, 0, sizeof(DisplayDevice));

	return dpy;
}


void
display_free (DisplayDevice *dpy)
{
	if (dpy)
		my_free ((char*) dpy);
}

