
/*=============================================================================
   beest, an HTML viewer.
   Copyright (C) 2000 Zachary Thayer Smith

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   The author is reachable by electronic mail at zeyr@excite.com.
=============================================================================*/

/*----------------------------------------------------------------------
 * Module name:    error.c
 * Author name:    Zach Smith
 * Create date:    1 Oct 2000
 * Last change:    26 Nov 2000
 * Purpose:        Error handling.
 *----------------------------------------------------------------------
 * Changes:
 *--------------------------------------------------------------------*/

#include <stdio.h>

#include "defs.h"
#include "main.h"
#include "error.h"

void usage () {
	fprintf (stderr,"usage: %s\n", USAGE); 
	if (logfile) fclose(logfile);
	exit(-1);
}

void error_handler (char* msg) {
	fprintf (stderr,"FATAL ERROR: %s\n",msg); 
	if (logfile) fclose(logfile);
#ifndef TURBO_C
	if (debug_mode)
	{
		char *x = 0;
		*x = 0;
	}
#endif
	exit(-2);
}

void warning_handler (char* msg) {
	if (logfile)
		fprintf (logfile,"WARNING: %s\n",msg); 
	else
		fprintf (stderr,"WARNING: %s\n",msg); 
}

